#pragma once
#include <atomic>

#include "KTexture.h"
#include "KVector2d.h"

namespace KapitanGame
{
	class KCamera;
	class KCollider;

	class KObject
	{
	public:
		KObject(const KVector2D& position, const KTexture& texture);
		virtual ~KObject() = default;
		void Render(SDL_Renderer* renderer, const KCamera& camera) const;
		KVector2D GetPosition() const;
		virtual const KCollider* GetCollider() const = 0;
		const int Id;
		static std::atomic<int> IdCounter;
	protected:
		KVector2D Position{ 0.f, 0.f };
	private:
		const KTexture& Texture;
	};
}

